# std::experimental::filesystem::resize_file

From cppreference.com
< cpp‎ | experimental‎ | fs

Defined in header `<experimental/filesystem>` |  |
void resize_file(const path& p, std::uintmax_t new_size); void resize_file(const path& p, std::uintmax_t new_size, error_code& ec); |  | (filesystem TS)

Changes the size of the regular file named by `p` as if by POSIX truncate: if the file size was previously larger than `new_size`, the remainder of the file is discarded. If the file was previously smaller than `new_size`, the file size is increased and the new area appears as if zero-filled.

### Parameters

p | - | path to delete
new_size | - | size that the file will now have
ec | - | out-parameter for error reporting in the non-throwing overload

### Return value

(none)

### Exceptions

The overload that does not take a `error_code&` parameter throws filesystem_error on underlying OS API errors, constructed with `p` as the first argument and the OS error code as the error code argument. std::bad_alloc may be thrown if memory allocation fails. The overload taking a `error_code&` parameter sets it to the OS API error code if an OS API call fails, and executes ec.clear() if no errors occur. This overload has
`noexcept` specification:
noexcept

### Notes

On systems that support sparse files, increasing the file size does not increase the space it occupies on the file system: space allocation takes place only when non-zero bytes are written to the file.

### Example

demonstrates the effect of creating a sparse file on the free space

Run this code

    #include <iostream>
    #include <iomanip>
    #include <fstream>
    #include <experimental/filesystem>
    namespace fs = std::experimental::filesystem;
    int main()
    {
        fs::path p = fs::current_path() / "example.bin";
        std::ofstream(p).put('a');
        std::cout << "File size: " << std::setw(10) << fs::file_size(p)
                  << " Free space: " << fs::space(p).free << '\n';
        fs::resize_file(p, 1024*1024*1024); // resize to 1 G
        std::cout << "File size: " << fs::file_size(p)
                  << " Free space: " << fs::space(p).free << '\n';
        fs::remove(p);
    }

Possible output:

    File size:          1 Free space: 3724541952
    File size: 1073741824 Free space: 3724476416

### See also

file_size | returns the size of a file (function)
space | determines available free space on the file system (function)

Retrieved from "http://en.cppreference.com/mwiki/index.php?title=cpp/experimental/fs/resize_file&oldid=77607"
Category:

- unconditionally noexcept

Hidden categories:

- Pages with unreviewed unconditional noexcept template
- Pages with unreviewed noexcept template